---- vlakCooldowns
-- Written by Vlakarados @ Soulflayer EU (ru) /  @  
-- Hugely Based on KordaCooldown by Korda @ Tarren Mill EU / henrik_s @ wowinterface.com
-- Thanks to the wowinterface community that helped report bugs and suggestions, Danpiel and Kavrishka ;)

local addon, ns = ...  

-- If you wish to add more spells to the list, simply add a line with a spell ID number and a comma. 
-- Text that goes after "--" is a comment and is there simply to remember what is what.
-- Spell ID number can be found at wowhead as last numbers in the address bar, 
-- e.g. http://www.wowhead.com/spell=47241 is a link to Metamorphosis spell and the spell ID is 47241

-- Some spells are commented out (disabled) with "--" to the left of spell ID number, remove/add -- before spell ID to enable/disable them.
-- Warriors and paladins sure have a hella-lot of cooldown abilities.

local aspells = {
	["PRIEST"] = {
		47585, -- Dispersion
		34433, -- Shadowfiend
		8092,  -- Mind Blast
		8122,  -- Psychic Scream
		64044, -- Psychic Horror
		586,   -- Fade
		15487, -- Silence
		64901, -- Hymn of Hope
		
		724,   -- Lightwell
		
		34861, -- Circle of Healing
		33076, -- Prayer of Mending
		64843, -- Divine Hymn
		47788, -- Guardian Spirit
		19236, -- Desperate Prayer
		10060, -- Power Infusion
		62618, -- Power Word: Barrier
		47540, -- Penance
		89485, -- Inner Focus
		81700, -- Archangel
		87153, -- Dark Archangel
		33206, -- Pain Supression
		6346,  -- Fear Ward
		
		-- Chakra stuff
		14751, -- Chakra
		88625, -- Holy Word: Chastise
		88682, -- HW: Aspire
		88684, -- HW: Serenity
		88685, -- HW: Sanctuary
		

	},
	["SHAMAN"] = {
		51490, -- 59159, -- Thunderstorm
		16166, -- Elemental Mastery // Bugged, shows this cooldown along with nature's swiftness as they share cooldowns
		
		16190, -- Mana Tide Totem
		16188, -- Nature's Swiftness // Bugged
		55198, -- Tidal Force
		
		51533, -- Feral Spirit
		30823, -- Shamanistic Rage
	},
	["ROGUE"] = {
		1856, -- Vanish
		5277, -- Evasion
		31224, -- Cloak of Shadows
		2983, -- Sprint
		2094, -- Blind
		
		51713, -- Shadow Dance
		14183, -- Premeditation
		14185, -- Preparation
		
		79140, -- Vendetta
		14177, -- Cold Blood
		
		13877, -- Blade Flurry
		51690, -- Killing Spree
		13750, -- Adrenaline Rush
	},
	["DRUID"] = {
		49376, -- Feral Charge - Cat
		16979, -- Feral Charge - Bear
		20484, -- 48477, -- Rebirth
		1850, -- 33357, -- Dash
		5209,   -- Challenging Roar
		22842, -- Frenzied Regeneration
		740, -- 48447, -- Tranquility
		5217, -- 50213, -- Tiger's Fury
		16689, -- 53312, -- Nature's Grasp
		
		48505, -- 53201, -- Starfall
		33831, -- Force of Nature
		50516, -- 61384, -- Typhoon
		
		50334, -- Berserk
		61336, -- Survival Instincts
		
		17116, -- Nature's Swiftness
	},
	["MAGE"] = {
		12472, -- Icy Veins
		122,   -- Frost Nova
		120,   -- Cone of Cold
		11426, -- Ice Barrier
		11958, -- Cold Snap
		44572, -- Deep Freeze
		31687, -- Water Elemental
		11113, -- Blast Wave
		31661, -- Dragon Breath
		11129, -- Combustion
		12043, -- Presense of Mind
		12042, -- Arcane Power
		45438, -- Ice Block
		543,   -- Magic Protection (Fire/Frost Ward)
		12051, -- Evocation
		2139,  -- Counterspell
		55342, -- Mirror Images
		1953,  -- Blink
		66,    -- Invisibility
		1463,  -- Mana Shield
	},
	["WARLOCK"] = {
		--5484, -- 
		5484, -- Howl of Terror
		--6789, -- 
		6789, -- Death Coil
		48020, -- Demonic Circle: Teleport
		29858, -- Soulshatter
		47897, -- Shadowflame
		79268, -- Soul Harvest
		74434, -- Soul Burn
		
		30283, -- Shadowfury

		47241, -- Metamorphosis
		18708, -- Fel Domination
	},
	["PALADIN"] = {
		498,   -- Divine Protection
		642,   -- Divine Shield
		2812,  -- Holy Wrath
		6940,  -- Hand of Sacrifice
		1022,  -- 10278, -- Hand of Protection
		1044,  -- Hand of Freedom
		1038,  -- Hand of Salvation
		633,   -- Lay on Hands
		31884, -- Avenging Wrath
		54428, -- Divine Plea
		20066, -- Repentance
		853,   -- Hammer of Justice
		31821, -- Aura Mastery
		20216, -- Divine Favor
		31850, -- Ardent Defender
		85222, -- Light of Dawn
		82327, -- Holy Radiance
	},
	["DEATHKNIGHT"] = {
		49016, -- Hysteria
		49028, -- Dancing Runic Blade
		55233, -- Vampiric Blood
		48982, -- Rune Tap
		49206, -- Summon Gargoyle
		48707, -- Anti-magic shield
		51052, -- Anti-magic zone
		49203, -- Hungering Cold
		49796, -- Deathchill
		51271, -- Unbreakable Armor
		49222, -- Bone Shield
		49938, -- Death and Decay
		48792, -- Icebound Fortitude
		47476, -- Strangulate
		45529, -- Blood Tap
		48743, -- Death Pact
		57330, -- Horn of Winter
		49576, -- Death Grip
		47568, -- Empower Rune Weapon
		-- 42650, -- Army of the Dead
	},
	["HUNTER"] = {
		5384, -- Feign Death
		781, -- Disengage
		34477, -- Misdirection
		53271, -- Master's Call
		3045, -- Rapid Fire
		1543, -- Flare
		19263, -- Deterrence
		19503, -- Scatter Shot
		
		-- Looks like hunters have different spell ID's for traps used with or without a launcher, test and report please.
		34600, -- Snake Trap
		82948, -- Snake Trap Launcher
		13813, -- Explosive Trap
		82939, -- Explosive Trap Launcher
		1499, -- Freezing Trap
		60192, -- Freezing Trap Launcher
		13795, -- Immolation Trap
		82945, -- Immolation Trap Launcher
		13809, -- Ice Trap
		82941, -- Ice Trap Launcher

	},
	["WARRIOR"] = {
		676,     -- Disarm
		
		1161,   -- Challenging Shout
		1719,   -- Recklessness
		2565,   -- Shield Block
		64382, -- Shattering Throw
		
		57755, -- Heroic Throw
		
		46968, -- Shockwave
		46924, -- Bladestorm
		12328, -- Sweeping Strikes
		85388, -- Throwdown
		60970, -- Heroic Fury
		12809, -- Concussion Blow
		12292, -- Death Wish
		
		5246,   -- Intimidating Shout
		18499, -- Berserker Rage
		20230, -- Retaliation
		
		871,     -- Shield Wall
		12975, -- Last Stand
		
		100, -- Charge
		20252, -- Intercept
		3411, -- Intervene
		
		355, -- Taunt
	},
	["RACE"] = {
		["Orc"] = {
			33697, -- Orc Blood Fury Shaman
			33702, -- Orc Blood Fury Warlock
			20572, -- Orc Blood Fury AP
		},
		["BloodElf"] = {
			25046, -- Blood Elf Arcane Torrent Rogue
			50613, -- BE AT DK
			28730, -- BE AT Mana users
		},
		["Scourge"] = {		
			20577, -- Cannibalize
			7744,   -- Will of the Forsaken
		},
		["Tauren"] = {
			20549, -- War Stomp
		},
		["Troll"] = {
			26297, -- Berserking
		},
		["Draenei"] = {
			59545, -- Gift of the Naaru DK
			59543, -- GotN Hunter
			59548, -- GotN Mage
			59542, -- GotN Paladin
			59544, -- GotN Priest
			59547, -- GotN Shaman
			28880, -- GotN Warrior
		},
		["Dwarf"] = {
			20594, -- Stoneform
		},
		["Gnome"] = {
			20589, -- Escape Artist
		},
		["Human"] = {
			59752, -- Every Man for Himself
		},
		["NightElf"] = {
			58984, -- Shadowmeld
		},		
	},
	
	["PET"] = {
		-- Warlock
		6360, -- Succubus Whiplash
		7812, -- Voidwalker Sacrifice
		19647, -- Felhunter Spell Lock
		--89808, -- Imp Singe Magic
		89766, -- Felguard Axe Toss
		89751, -- Felguard Felstorm
		30151, -- Felguard Pursuit
		
		-- Hunter
		
	},
}
ns.aspells = aspells