---- vlakCooldowns
-- Written by Vlakarados @ Soulflayer EU (ru) /  @  
-- Hugely Based on KordaCooldown by Korda @ Tarren Mill EU / henrik_s @ wowinterface.com
-- Thanks to the wowinterface community that helped report bugs and suggestions, Danpiel and Kavrishka ;)

local addon, ns = ...  
local aspells = ns.aspells

local fade = 0 -- 0 one color, 1 fades from green to red, 2 fades from red to green

local vtexture = "Interface\\AddOns\\vlakCooldowns\\bartexture"
local vfont = "Interface\\AddOns\\vlakCooldowns\\font.ttf"
local tfont = "Interface\\Addons\\MyMedia\\font\\BANK.TTF"

local showmessages = 1

local growth = 0 -- 0 - centered, 1 - right or up, 2 - left or down
local valign = 1 -- 1 Horizontal, 0 Vertical

-- Defaults
local ypos = 405
local xpos = 506
local size = 40

-- Gap between icons
local gap = 3

-- Timer update throttle (in seconds). The lower, the more precise. Set it to a really low value and don't blame me for low fps
local throttle = 0.3

local spells = {}

----
local SetPoint = SetPoint
local GetTime = GetTime
local SetWidth = SetWidth
local SetValue, GetValue = SetValue, GetValue
local Show, Hide = Show, Hide
local pairs = pairs

local vcd= "|cffFFFFFFvlak|r|cffC8FF00C|r|cffFFFFFFooldowns:|r"


-- Import your class abilities
local frames = { }
spells = aspells[select(2, UnitClass("player"))]

-- And Race
local race = aspells["RACE"]
for i = 1, table.getn(race[select(2, UnitRace("player"))]) do
	table.insert(spells, race[select(2, UnitRace("player"))][i]);
end

-- And Pet, if you have one
local _, pcl = UnitClass("player")
local _, pra = UnitRace("player")
if pcl == "WARLOCK" or pcl == "HUNTER" then
	for i = 1, table.getn(aspells["PET"]) do
		table.insert(spells, aspells["PET"][i]);
	end
end

-- Text on the screen when cooldown is ready
local msg = CreateFrame("MessageFrame", "vlakCooldownsMessage", UIParent)
msg:SetHeight(32)
msg:SetInsertMode("TOP")
msg:SetFrameStrata("HIGH")
msg:SetPoint("TOPLEFT", UIParent, "CENTER", -240, -20)
msg:SetPoint("BOTTOMRIGHT", UIParent, "CENTER", -40, -52)
msg:SetTimeVisible(1)
msg:SetFadeDuration(1)
msg:SetFont(tfont, 16, "THINOUTLINE")

-- Main anchor
local anchor = CreateFrame("Frame", "vlakCooldownsAnchor", UIParent)
anchor:SetHeight(size)
anchor:SetWidth(size-4)
anchor.texture = anchor:CreateTexture("texture", "BACKGROUND")
anchor.texture:SetAllPoints(anchor)
anchor.texture:SetTexture(0,0.35,0, 0)
anchor:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", xpos, ypos) -- this will be reset in events, but..

danchor = CreateFrame("Frame", "vlakCooldownsDynamicAnchor", anchor) -- Dynamic anchor
danchor:SetHeight(size)
danchor:SetWidth(size-4)
danchor:SetPoint("BOTTOMLEFT", anchor, "BOTTOMLEFT", 0, 0)
danchor.texture = danchor:CreateTexture("texture", "BACKGROUND")
danchor.texture:SetAllPoints(danchor)
danchor.texture:SetTexture(1,0.35,0, 0) -- debug purpuse



local function ShowTooltip()
	GameTooltip:SetOwner(anchor, "ANCHOR_CURSOR")
	GameTooltip:AddLine(vcd)
    GameTooltip:AddDoubleLine("Drag: ", "Move cooldowns", 1, 1, 1, 1, 1, 1)
    GameTooltip:AddDoubleLine("Right click: ", "Set Size", 1, 1, 1, 1, 1, 1)
    --GameTooltip:AddDoubleLine("SetPortraitZoom", self.zoomLevel, 1, 1, 1, 1, 1, 1)    
	GameTooltip:Show()

end

local thevalue
local function position()
	
	local shown = 0
	for k,v in pairs(frames) do
		local frame = frames[k]
		
		-- Check if the spell is in the spellbook. E.G. will of the forsaken will show as a black icon if you're not a Forsaken, when using a PvP trinket, as it has 45s shared cooldown.
		if (GetSpellInfo(GetSpellInfo(frame.spell)) or pcl == "PRIEST")then
			local start, duration = GetSpellCooldown(frame.spell)
			if duration and duration > 1.5 then
				
				frame.start = start
				frame.duration = duration
				frame.bar:SetValue((frame.start - (GetTime() - frame.duration))/frame.duration)
				frame.tdur:SetText(math.floor(frame.start - (GetTime() - frame.duration)))
				
				-- fix for setting textures again when respecced. lol.
				-- Holy Word: ... Chakra state spell textures fix, sets all Holy Word: something textures to Holy Word: Chastise
				if ((pcl == "PRIEST") and (frame.spell == 88682 or frame.spell == 88684 or frame.spell == 88685)) then
					frame.ttexture:SetTexture(GetSpellTexture(GetSpellInfo(88625)))
				else
					frame.ttexture:SetTexture(GetSpellTexture(GetSpellInfo(frame.spell)))
				end
				
				
				if (valign == 1) then
					-- Horizontal
					frame:SetPoint("BOTTOMLEFT", danchor, "BOTTOMLEFT", shown * (size-4+gap), 0)
				else
					-- Vertical
					frame:SetPoint("BOTTOMLEFT", danchor, "BOTTOMLEFT", 0, shown * (size+gap))
				end
				shown = shown + 1
				frame:Show()
			end
		end
	end
	
	
	
	if (shown>0) then
		thevalue = shown-1
	else
		thevalue = shown
	end
	
	if (valign == 1) then
		if (growth == 1) then
			danchor:SetPoint("BOTTOMLEFT", anchor, "BOTTOMLEFT", 0, 0)
		elseif (growth == 2) then
			danchor:SetPoint("BOTTOMLEFT", anchor, "BOTTOMLEFT", -(thevalue*(size-4+gap)), 0)
		else
			danchor:SetPoint("BOTTOMLEFT", anchor, "BOTTOMLEFT", -0.5*(thevalue*(size-4+gap)), 0)
		end
	else
		if (growth == 1) then
			danchor:SetPoint("BOTTOMLEFT", anchor, "BOTTOMLEFT", 0, 0)
		elseif (growth == 2) then
			danchor:SetPoint("BOTTOMLEFT", anchor, "BOTTOMLEFT", 0, -(thevalue*(size+gap)))
		else
			if (thevalue==1) then
				thevalue = 0
			end
			danchor:SetPoint("BOTTOMLEFT", anchor, "BOTTOMLEFT", 0, -0.5*(thevalue*(size+gap)))
		end	
	end
end

-- Update function
local function timer(self, elapsed)
	self.lastupdate = self.lastupdate + elapsed
	if self.lastupdate > throttle then
		local p = (self.start - (GetTime() - self.duration))/self.duration
		self.bar:SetValue(p)
		
		-- if fade is 1 make it gradient, else keep it as it was
		if fade == 1 then
			self.bar:GetStatusBarTexture():SetVertexColor(1-p, p, 0/255);
		elseif fade == 2 then	
			self.bar:GetStatusBarTexture():SetVertexColor(p, 1-p, 0/255);
		end
		
		self.tdur:SetText(math.floor((self.start - (GetTime() - self.duration))))
		if self.bar:GetValue() < 0.05 then
			self:Hide()
			position()
		end
		
		local _, ddur = GetSpellCooldown(self.spell)
		if ddur == 0 then
			msg:AddMessage(GetSpellInfo(self.spell), 200/255, 255/255, 0/255)
			self:Hide()
			position()
		end

		self.lastupdate = 0
	end
end

-- Frames
local function create(spell)

	-- Background
	local frame = CreateFrame("Frame", nil, UIParent)
	frame:SetHeight(size)
	frame:SetWidth(size-4)
	frame.texture = frame:CreateTexture("texture", "BACKGROUND")
	frame.texture:SetAllPoints(frame)
	frame.texture:SetTexture(0,0,0, 0.85)
	
	-- Cooldown Texture
	local texture = frame:CreateTexture()
	texture:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 2, 2)
	-- Holy Word: ... Chakra state spell textures fix, sets all Holy Word: something textures to Holy Word: Chastise
	if ((pcl == "PRIEST") and (spell == 88682 or spell == 88684 or spell == 88685)) then
		texture:SetTexture(GetSpellTexture(GetSpellInfo(88625)))
	else
		texture:SetTexture(GetSpellTexture(GetSpellInfo(spell)))
	end
	texture:SetTexCoord(0.08,0.92,0.08,0.92)
	texture:SetHeight(size-8)
	texture:SetWidth(size-8)
	
	-- Text Timer
	local tdur = frame:CreateFontString(nil, "OVERLAY")
    tdur:SetFont(vfont, 12, "OUTLINE")
    tdur:SetShadowColor(0,0,0,1)
	tdur:SetText("")
	tdur:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 2, 2)
	
	-- Status Bar Timer
	local bar = CreateFrame("StatusBar", nil, frame, "TextStatusBar")
	bar:SetStatusBarTexture(vtexture)
	bar:GetStatusBarTexture():SetVertexColor(255/255, 200/255, 0/255);
	bar:SetPoint("TOPLEFT", frame, "TOPLEFT", 2, -2)
	bar:SetHeight(3)
	bar:SetWidth(size-8)
	bar:SetMinMaxValues(0, 1)
	
	frame.bar = bar
	frame.tdur = tdur
	frame.ttexture = texture
	frame.lastupdate = 0
	frame.spell = spell
	
	frame:SetScript("OnUpdate", timer)
	frame:Hide()
	
	return frame
end
		

local menuFrame = CreateFrame("Frame", "ExampleMenuFrame", UIParent, "UIDropDownMenuTemplate")
local function mouseclick(self, button)

	local menu = {
		{ text = vcd, isTitle = true,notCheckable = true},
		{ text = "", notCheckable = true},
		{ text = "Align", hasArrow = true, notCheckable = true, menuList = {

				{ text = "Horizontal", checked = (valign==1), func = function() valign = 1; vlakcd_align = 1; position(); end },
				{ text = "Vertical", checked = (valign==0), func = function() valign = 0; vlakcd_align = 0; position(); end },
				
			} 
		},
		{ text = "Growth", hasArrow = true, notCheckable = true, menuList = {

				{ text = "Right or Up", checked = (growth==1), func = function() growth = 1; vlakcd_growth = 1; position(); end },
				{ text = "Left or Down", checked = (growth==2), func = function() growth = 2; vlakcd_growth = 2; position(); end },
				{ text = "Centered", checked = (growth==0), func = function() growth = 0; vlakcd_growth = 0; position(); end },
				
			} 
		},
			
		{ text = "Icon options", hasArrow = true, notCheckable = true,
			menuList = {
				{ text = "Set icon size", notCheckable = true, func = function() StaticPopup_Show("VCSETSIZE") end },
			} 
		},
		{ text = "Get Spell List", notCheckable = true, func = function() 	
		for k, v in pairs(frames) do
			local spname = select(1, GetSpellInfo(k))
			print(spname)
		end end },
	}
	if button == "RightButton" then
		EasyMenu(menu, menuFrame, "cursor", 0 , 0, "MENU");
	end

	anchor:StopMovingOrSizing()

end

-- Slash
SLASH_VLAKCD1, SLASH_VLAKCD2, SLASH_VLAKCD3 = '/vlakcd', '/vc', '/vlakcooldowns';
function SlashCmdList.VLAKCD(msg, editbox)
		
	if(anchor:IsMovable()) then
		print(vcd, "Config mode disabled, position saved")
		vlakcd_xpos = anchor:GetLeft()
		vlakcd_ypos = anchor:GetBottom()
		vlakcd_size = anchor:GetHeight()
		anchor.texture:SetTexture(0,0.35,0, 0)
		anchor:SetMovable(false)
		anchor:SetResizable(false)
		anchor:EnableMouse(false)	
		anchor:SetScript("OnEnter", function(s) end)
		anchor:SetScript("OnLeave", function(s) end)
	else
		
		print(vcd, "Config mode enabled, drag to reposition, right click for other options, /vc to save position")
		anchor:SetWidth(size-4)
		anchor.texture:SetTexture(0,0.35,0, 0.85)
		anchor:SetMovable(true)
		anchor:SetResizable(true)
		anchor:EnableMouse(true)
		--anchor:SetScript("OnEnter", function(s) ShowTooltip() end)
		--anchor:SetScript("OnLeave", function(s) GameTooltip:Hide() end)
		anchor:SetScript("OnMouseUp", mouseclick)
		anchor:SetScript("OnMouseDown", anchor.StartMoving)
	end
end

StaticPopupDialogs["VCSETSIZE"] = {
	text = "Enter the size of the button (height)",
	button1 = "OK",
	button2 = "Cancel",
	timeout = 0,
	whileDead = true,
	hideOnEscape = true,
	hasEditBox = true,
	enterClicksFirstButton = true,
	exclusive = true,
	OnShow = function (self, data)
		self.editBox:SetText(size)
	end,
	OnAccept = function (self, data, data2)
    local text = self.editBox:GetText()
		if (tonumber(text)) then
			vlakcd_size = text
			size = text
			anchor:SetWidth(size-4)
			anchor:SetHeight(size)
			
			for k, v in pairs(frames) do
				
				v:SetHeight(size)
				v:SetWidth(size-4)
				v.ttexture:SetHeight(size-8)
				v.ttexture:SetWidth(size-8)
				v.bar:SetWidth(size-8)
			end
			position()
			
		else
			print(vcd, "Error: size is not a number")
		end
		
		
	end,
	EditBoxOnEscapePressed = function(frame) frame:GetParent():Hide() end,
}



-- Event Handling
local function event(self, event, arg1)
	if event == "SPELLS_CHANGED" or event == "PLAYER_ENTERING_WORLD" or event == "PLAYER_TALENT_UPDATE" then	
		for k, v in pairs(spells) do
			if GetSpellInfo(v) then
				frames[v] = frames[v] or create(spells[k])
			end
		end
	end
	
	if event == "SPELL_UPDATE_COOLDOWN" then
		position()
	end
	
	if event == "ADDON_LOADED" and arg1 == "vlakCooldowns" then
		
		-- Saved variables resurrection
		xpos = vlakcd_xpos or xpos
		ypos = vlakcd_ypos or ypos
		size = vlakcd_size or size
		gap = vlakcd_gap or gap
		valign = vlakcd_align or valign
		growth = vlakcd_growth or growth

		anchor:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", xpos, ypos)
	end
end




local vlakCooldowns = CreateFrame("Frame")
vlakCooldowns:RegisterEvent("PLAYER_ENTERING_WORLD")
vlakCooldowns:RegisterEvent("SPELL_UPDATE_COOLDOWN")
vlakCooldowns:RegisterEvent("SPELLS_CHANGED")
vlakCooldowns:RegisterEvent("PLAYER_TALENT_UPDATE")
vlakCooldowns:RegisterEvent("ADDON_LOADED")
vlakCooldowns:SetScript("OnEvent", event)